Subject: Re: [PATCH RFC] virtio_net: fix refill related races

From: Rusty Russell <[email-masked]>
Date: Tue, 13 Dec 2011 13:05:11 +1030

On Mon, 12 Dec 2011 13:54:06 +0200, "Michael S. Tsirkin" <[email-masked]> wrote:
> On Mon, Dec 12, 2011 at 09:25:07AM +1030, Rusty Russell wrote:
> > Orthogonally, the refill-stop code is still buggy, as you noted.
> 
> Sorry I don't understand how it's still buggy.

Both places where we call:

	cancel_delayed_work_sync(&vi->refill);

Do not actually guarantee that vi->refill isn't running, because it
can requeue itself.  A 'bool no_more_refill' field seems like the
simplest fix for this, but I don't think it's sufficient.

Tejun, is this correct?  What's the correct way to synchronously stop a
delayed_work which can "schedule_delayed_work(&vi->refill, HZ/2);" on
itself?

Thanks,
Rusty.